package com.galaxis.manatee.dao;


import com.galaxis.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunLaborCostDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunPersonDaysDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ChuanyunPersonDaysDao extends GalaxisRepository<ChuanyunPersonDaysDO,String> {

//    @Query(value="SELECT total.project_id AS object_id,SUM((self_work_hour.hours_worked / total.total_hour) * 8) / 8 AS person_days FROM(SELECT project_id,SUM(chuanyun_day_log.hours_worked)AS total_hour,user_id FROM chuanyun_project"+
//            " LEFT JOIN chuanyun_day_log ON chuanyun_day_log.project_id = chuanyun_project.object_id LEFT JOIN chuanyun_log ON chuanyun_log.object_id = chuanyun_day_log.parent_object_id"+
//            " GROUP BY chuanyun_project.object_id) total LEFT JOIN (SELECT chuanyun_day_log.hours_worked,chuanyun_log.user_id,chuanyun_day_log.project_id,chuanyun_day_log.project_type"+
//            " FROM chuanyun_day_log LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id WHERE chuanyun_day_log.project_type NOT IN ('生产项目','管理项目')"+
//            "GROUP BY chuanyun_day_log.project_id,chuanyun_log.user_id,chuanyun_day_log.day_log_date) self_work_hour ON self_work_hour.user_id = total.user_id WHERE total.project_id =?",nativeQuery = true)
//    ChuanyunPersonDaysDO getPersonDays(String projectId);

    /**
     * 项目每人每天工时
     * @param projectId
     * @return
     */
    @Query(value="SELECT chuanyun_day_log.object_id,chuanyun_day_log.hours_worked,chuanyun_log.user_id,chuanyun_day_log.project_id,chuanyun_day_log.project_type FROM chuanyun_day_log"+
            "\tLEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id WHERE project_id = ?"+
            "\tGROUP BY chuanyun_day_log.project_id,chuanyun_log.user_id,chuanyun_day_log.day_log_date",nativeQuery = true)
    List<ChuanyunPersonDaysDO> getSelfWorkHour(String projectId);

    /**
     * 项目总工时
     * @param projectId
     * @return
     */
    @Query(value="SELECT chuanyun_day_log.object_id,SUM(chuanyun_day_log.hours_worked) AS hours_worked,chuanyun_log.user_id,chuanyun_day_log.project_id FROM chuanyun_day_log"+
            " LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id WHERE chuanyun_log.user_id = ?1 AND chuanyun_day_log.project_id=?2"+
            " GROUP BY chuanyun_day_log.project_id,chuanyun_log.user_id",nativeQuery = true)
    ChuanyunPersonDaysDO getTotalWorkHour(String userId,String projectId);

}
