package com.galaxis.manatee.dao;


import com.galaxis.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunSelfWorkHourDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunWorkHourDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;
import java.util.List;

@Repository
public interface ChuanyunSelfWorkHourDao extends GalaxisRepository<ChuanyunSelfWorkHourDO,String> {

    ChuanyunSelfWorkHourDO findByUserIdAndAndProjectIdAndAndDayLogDate(String userId, String projectId, LocalDateTime dayLogDate);

    @Query(value="SELECT SUM(chuanyun_self_work_hour.standard_work_hour) AS standard_work_hour,chuanyun_self_work_hour.day_log_date,chuanyun_self_work_hour.user_id,chuanyun_self_work_hour.project_id,chuanyun_self_work_hour.object_id FROM chuanyun_self_work_hour WHERE chuanyun_self_work_hour.user_id=?"+
            " GROUP BY chuanyun_self_work_hour.user_id,FROM_UNIXTIME(chuanyun_self_work_hour.day_log_date,'%Y-%m'),chuanyun_self_work_hour.project_id",nativeQuery = true)
    List<ChuanyunSelfWorkHourDO> getMonthProjectHour(String userId);

    @Query(value="SELECT SUM(chuanyun_self_work_hour.standard_work_hour) AS standard_work_hour,chuanyun_self_work_hour.day_log_date,chuanyun_self_work_hour.user_id,chuanyun_self_work_hour.project_id,chuanyun_self_work_hour.object_id"+
            " FROM chuanyun_self_work_hour WHERE chuanyun_self_work_hour.user_id= ?1 AND DATE_FORMAT(chuanyun_self_work_hour.day_log_date,'%Y-%m')=DATE_FORMAT(?2,'%Y-%m')"+
            " GROUP BY chuanyun_self_work_hour.user_id,DATE_FORMAT(chuanyun_self_work_hour.day_log_date,'%Y-%m')",nativeQuery = true)
    ChuanyunSelfWorkHourDO getMonthHour(@Param("userId") String userId,@Param("dayLogDate") String dayLogDate);
}
