package com.galaxis.manatee.dao;


import com.galaxis.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunWorkHourDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;
import java.util.List;

@Repository
public interface ChuanyunWorkHourDao extends GalaxisRepository<ChuanyunWorkHourDO,String> {

    @Query(value="SELECT chuanyun_day_log.object_id,chuanyun_day_log.hours_worked,chuanyun_day_log.project_id,chuanyun_log.user_id,chuanyun_day_log.day_log_date FROM chuanyun_day_log"+
            " LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id WHERE chuanyun_log.user_id = ? ORDER BY day_log_date",nativeQuery = true)
    List<ChuanyunWorkHourDO> getSelfWorkHour(String userId);

    @Query(value="SELECT chuanyun_day_log.object_id,SUM(chuanyun_day_log.hours_worked) AS hours_worked,chuanyun_day_log.project_id,chuanyun_log.user_id,chuanyun_day_log.day_log_date FROM chuanyun_day_log"+
            " LEFT JOIN chuanyun_log ON chuanyun_day_log.parent_object_id = chuanyun_log.object_id WHERE chuanyun_log.user_id = ? AND chuanyun_day_log.day_log_date =? GROUP BY chuanyun_log.user_id,chuanyun_day_log.day_log_date",nativeQuery = true)
    ChuanyunWorkHourDO getDayWorkHour(String userId, LocalDateTime day);
}
